#include "functions_codes.h"

#define FORW FORWARD_DIRECTION
#define BACK BACKWARD_DIRECTION
#define STOP STOP_DIRECTION

// ir is on the black line
#define IR(i) ir(i, 0, NONE)

#define MOTOR_L(direction, speed) dc_motor(LEFT_MOTOR_1, direction, speed);
#define MOTOR_R(direction, speed) dc_motor(RIGHT_MOTOR_1, direction, speed);
#define DELAY(x) delay(0, 0, 0, x);

#define SPEED 10
#define SPEED_TURN 5

char ir[3];

int main ()
{
    mcu_initialization();
    
    while (true)
    {
        ir[0] = IR(1);
        ir[1] = IR(2);
        ir[2] = IR(3);
        
        // line is on center
        if (!ir[0] && ir[1] && !ir[2})
        {
            MOTOR_L(FORW, SPEED);
            MOTOR_R(FORW, SPEED);
        }
        
        /*
            soft turn
        */
        // line is on the left side
        if (ir[0] && ir[1] && !ir[2})
        {
            MOTOR_L(FORW, SPEED_TURN);
            MOTOR_R(FORW, SPEED);
        }
        
        // line is on the right side
        if (!ir[0] && ir[1] && ir[2})
        {
            MOTOR_L(FORW, SPEED);
            MOTOR_R(FORW, SPEED_TURN);
        }
        
        /*
            fast turn
        */
        // line is on the left side
        if (ir[0] && !ir[1] && !ir[2})
        {
            MOTOR_L(FORW, 0);
            MOTOR_R(FORW, SPEED);
        }
        
        // line is on the right side
        if (!ir[0] && !ir[1] && ir[2})
        {
            MOTOR_L(FORW, SPEED);
            MOTOR_R(FORW, 0);
        }
    }

    return 0;
}
